#include <bits/stdc++.h>
using namespace std;
int n,k,a[200005],counter=0,counter2=0,maxi,maxi2=-10e7,vrednost1,vrednost2,vrednost3,vrednost4;
int main(){
    cin >> n >> k;
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    counter2=n;
    for(int i=0; i<k-1; i++){
        if(i=k-2){
        vrednost1=(a[counter]-a[counter2]);
        vrednost2=(a[counter2]-a[counter]);
        }
        else{
        vrednost1=(a[counter]-a[counter2])+(a[counter2-1]-(a[counter]-a[counter2]));
        vrednost2=(a[counter2]-a[counter])+(a[counter+1]-(a[counter2]-a[counter]));
        vrednost3=(a[counter]-a[counter2])+((a[counter]-a[counter2])-a[counter2-1]);
        vrednost4=(a[counter2]-a[counter])+((a[counter2]-a[counter])-a[counter+1]);
        }
        maxi=max(max(max(vrednost1,vrednost2),vrednost3),vrednost4);
        if(maxi==vrednost1 || maxi==vrednost3){
            a[counter]-=counter2;
            counter2--;
        }
        else{
            a[counter2]-=a[counter];
            counter++;
        }
    }
    for(int i=counter; i<counter2; i++){
        maxi2=max(maxi2,a[i]);
    }
    cout << maxi2 << endl;
    return 0;
}